diff --git a/src/backend/executor/nodeGather.c b/src/backend/executor/nodeGather.c
index 438d1b2..bc56f0e 100644
--- a/src/backend/executor/nodeGather.c
+++ b/src/backend/executor/nodeGather.c
@@ -348,7 +348,8 @@ gather_readnext(GatherState *gatherstate)
 			--gatherstate->nreaders;
 			if (gatherstate->nreaders == 0)
 			{
-				ExecShutdownGatherWorkers(gatherstate);
+				pfree(gatherstate->reader);
+				gatherstate->reader = NULL;
 				return NULL;
 			}
 			memmove(&gatherstate->reader[gatherstate->nextreader],
